## dpkg 1.22.21ubuntu4

=== tests/t-conffile-divert-conffile/Makefile ===
TESTS_DEB := pkg-conff pkg-conff-divert

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conff.deb
	# test if the other package can divert the conffile w/o prompt
	$(DPKG_INSTALL) pkg-conff-divert.deb

test-clean:
	$(DPKG_PURGE) pkg-conff-divert
	$(DPKG_PURGE) pkg-conff

=== tests/t-conflict-provide-replace-virtual/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-a.deb
	# test if the conflicting package fails on install
	! $(DPKG_INSTALL) pkg-b.deb

test-clean:
	-$(DPKG_PURGE) pkg-b
	$(DPKG_PURGE) pkg-a

=== tests/t-deb-lfs/Makefile ===
PKG_SFS := pkg-sfs
PKG_LFS := pkg-lfs

TESTS_DEB := $(PKG_LFS) $(PKG_SFS)

# This will test both the ar archive and the tar LFS support.
DPKG_DEB_OPTIONS = -Znone

include ../Test.mk

$(PKG_LFS)/large-file:
	dd if=/dev/zero of=$@ bs=1K count=5M

$(PKG_SFS)/small-file:
	yes | dd of=$@ bs=1K count=4

build-hook: $(PKG_LFS)/large-file $(PKG_SFS)/small-file

clean-hook:
	$(RM) $(PKG_LFS)/large-file $(PKG_SFS)/small-file

test-case:
	# test Small File Support packages
	$(DPKG_INSTALL) pkg-sfs.deb
	$(call pkg_is_installed,pkg-sfs)
	test "`stat -c%s '$(DPKG_INSTDIR)/small-file'`" = "4096"
	
	# test Large File Support packages
	$(DPKG_INSTALL) pkg-lfs.deb
	$(call pkg_is_installed,pkg-lfs)
	test "`stat -c%s '$(DPKG_INSTDIR)/large-file'`" = "5368709120"

test-clean:
	$(DPKG_PURGE) pkg-sfs
	$(DPKG_PURGE) pkg-lfs

=== tests/t-disappear-depended/Makefile ===
TESTS_DEB := pkg-normal pkg-depend pkg-disappear

include ../Test.mk

test-case:
	# Test disappearing depended package.
	$(DPKG_INSTALL) pkg-disappear.deb
	$(DPKG_INSTALL) pkg-depend.deb
	$(DPKG_INSTALL) pkg-normal.deb
	# Should not disappear while it is being depended on.
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-depend
	$(DPKG_PURGE) pkg-normal
	:
	# Should disappear now that it is not being depended on.
	$(DPKG_INSTALL) pkg-disappear.deb
	$(DPKG_INSTALL) pkg-normal.deb
	# Should have been disappeared now.
	$(call pkg_is_not_installed,pkg-disappear)

test-clean:
	-$(DPKG_PURGE) pkg-depend
	-$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== tests/t-multiarch/Makefile ===
# Copyright © 2011 Linaro Limited
# Copyright © 2011 Raphaël Hertzog <hertzog@debian.org>
# Copyright © 2011-2012 Guillem Jover <guillem@debian.org>

TESTS_DEB :=

include ../Test.mk

NATIVE_ARCH := $(shell dpkg --print-architecture)
ifeq ($(NATIVE_ARCH),i386)
	FOREIGN_ARCH := amd64
else
	FOREIGN_ARCH := i386
endif

ma-setup:
	$(DPKG) --add-architecture $(FOREIGN_ARCH)

## BUILDING THE TEST PACKAGES ##

# Params are (dirname, pkgname, ver, arch, ma, dep)
# Dirname and pkgname are auto-prefixed with "pkg-ma"
define build_pkg
PKG_TO_BUILD += pkg-ma-$(1).deb

pkg-ma-$(1):: pkg-template
	[ -e pkg-ma-$(1) ] || cp -a pkg-template pkg-ma-$(1)
	sed -i -e "s/Package: .*/Package: pkg-ma-$(2)/" \
	       -e "s/Version: .*/Version: $(3)/" \
	       -e "s/Architecture: .*/Architecture: $(4)/" \
	       -e "s/Multi-Arch: .*/Multi-Arch: $(5)/" \
	       -e "s/Depends:.*/Depends: $(6)/" \
	    pkg-ma-$(1)/DEBIAN/control
	mkdir -p pkg-ma-$(1)/m-a
	echo "In file pkg-ma-$(1)" > pkg-ma-$(1)/m-a/foo-$(1)
	touch pkg-ma-$(1)

pkg-ma-$(1).deb: pkg-ma-$(1)
	$(DPKG_BUILD_DEB) --no-check pkg-ma-$(1) pkg-ma-$(1).deb

clean-hook::
	rm -rf pkg-ma-$(1)
	rm -f pkg-ma-$(1).deb
endef

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach ma,same foreign allowed no,\
    $(foreach version,1.0 2.0,\
      $(eval $(call build_pkg,$(ma)_$(version)_$(arch),$(ma),$(version),$(arch),$(ma),)))))

# Arch: all done separately because M-A: same can't be Arch: all
$(foreach ma,foreign allowed no,\
  $(eval $(call build_pkg,$(ma)_1.0_all,$(ma),1.0,all,$(ma),)))

$(eval $(call build_pkg,same_1.0_all,same,1.0,all,no,))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,self-conflict_1.0_$(arch),self-conflict,1.0,$(arch),same,))\
  $(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
    $(eval $(call build_pkg,dep-on-$(ma)_1.0_$(arch),dep-on-$(ma),1.0,$(arch),foreign,pkg-ma-$(subst -,:,$(ma)) (>= 1.0)))))

$(foreach ma,same foreign foreign-any allowed allowed-any allowed-fake no,\
  $(eval $(call build_pkg,dep-on-$(ma)_1.0_all,dep-on-$(ma),1.0,all,no,pkg-ma-$(subst -,:,$(ma)) (>= 1.0))))

shared_file_types := file symlink fifo
ifdef DPKG_AS_ROOT
shared_file_types += chardev blockdev
endif
$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(foreach version,1.0 2.0,\
    $(eval $(call build_pkg,shared-conffiles_$(version)_orig_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(eval $(call build_pkg,shared-conffiles_$(version)_alt_$(arch),shared-conffiles,$(version),$(arch),same,))\
    $(foreach variant,orig alt,\
      $(foreach type,$(shared_file_types),\
        $(eval $(call build_pkg,shared-files_$(version)_$(variant)-$(type)_$(arch),shared-files,$(version),$(arch),same,))))))

$(foreach arch,$(NATIVE_ARCH) $(FOREIGN_ARCH),\
  $(eval $(call build_pkg,triggers_1.0_$(arch),triggers,1.0,$(arch),same,))\
  $(eval $(call build_pkg,shared-diversion_1.0_$(arch),shared-diversion,1.0,$(arch),same,)))

$(eval $(call build_pkg,act-trig_1.0_all,act-trig,1.0,all,no,))
$(eval $(call build_pkg,diversion_1.0_all,diversion,1.0,all,no,))
$(eval $(call build_pkg,diverted_1.0_all,diverted,1.0,all,no,))
$(eval $(call build_pkg,db-layout_1.0_$(NATIVE_ARCH),db-layout,1.0,$(NATIVE_ARCH),no,))
$(eval $(call build_pkg,db-layout_2.0_$(NATIVE_ARCH),db-layout,2.0,$(NATIVE_ARCH),same,))

build-hook: $(PKG_TO_BUILD)

## TEST CASES BELOW ##

TEST_CASES += test-print-foreign-architecture
TEST_CASES += test-build-invalid
TEST_CASES += test-build-valid
TEST_CASES += test-install-native
TEST_CASES += test-install-foreign
TEST_CASES += test-coinstall-ma-same
TEST_CASES += test-crossgrade
TEST_CASES += test-deps
TEST_CASES += test-coinstall-shared-files
TEST_CASES += test-coinstall-shared-conffiles
TEST_CASES += test-coinstall-triggers
TEST_CASES += test-coinstall-diversions
TEST_CASES += test-dpkg-output
TEST_CASES += test-db-layout

test-case: $(TEST_CASES)

test-print-foreign-architecture:
	echo $(FOREIGN_ARCH) >ref-arch
	echo foobar >>ref-arch
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	$(DPKG) --remove-architecture foobar
	$(call stdout_is,$(DPKG) --print-foreign-architectures,)
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(call stdout_is,$(DPKG) --print-foreign-architectures,$(FOREIGN_ARCH))
	$(DPKG) --add-architecture foobar
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	# Ensure all/any can't be added as foreign arch
	! $(DPKG) --add-architecture all
	! $(DPKG) --add-architecture any
	# Ensure the native arch is never considered as
	$(DPKG) --add-architecture $(NATIVE_ARCH)
	$(DPKG) --print-foreign-architectures | cmp ref-arch -
	$(DPKG) --remove-architecture foobar
	rm -f ref-arch

test-build-invalid:
	# Test build of Architecture: all with Multi-Arch: same field
	! $(DPKG_BUILD_DEB) pkg-template foo.deb
	rm -f foo.deb

test-build-valid:
	# Test build of package with valid dependency (ma-allowed:fake)
	$(DPKG_BUILD_DEB) pkg-ma-dep-on-allowed-fake_1.0_$(NATIVE_ARCH) foo.deb
	rm -f foo.deb

test-install-native:
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign)
	$(call pkg_is_installed,pkg-ma-allowed)
	$(call pkg_is_installed,pkg-ma-no)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-foreign pkg-ma-allowed pkg-ma-no
	$(call pkg_is_not_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign)
	$(call pkg_is_not_installed,pkg-ma-allowed)
	$(call pkg_is_not_installed,pkg-ma-no)

test-install-foreign:
	$(DPKG) --remove-architecture $(FOREIGN_ARCH)
	# Installation of foreign arch packages must fail by default
	! $(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Once architecture has been added it should succeed
	$(DPKG) --add-architecture $(FOREIGN_ARCH)
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(FOREIGN_ARCH) pkg-ma-foreign:$(FOREIGN_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH) pkg-ma-no:$(FOREIGN_ARCH)
	$(call pkg_is_not_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-foreign:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-allowed:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))

test-coinstall-ma-same: ma-setup
	# Coinstall 2 Multi-Arch: same packages
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	# Upgrade one, the other must be unconfigured
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(NATIVE_ARCH).deb
	$(call pkg_status_is,pkg-ma-same:$(NATIVE_ARCH),install ok unpacked)
	$(call pkg_status_is,pkg-ma-same:$(FOREIGN_ARCH),install ok half-configured)
	# Configure one alone must fail
	! $(DPKG_CONFIGURE) pkg-ma-same:$(NATIVE_ARCH)
	! $(DPKG_CONFIGURE) pkg-ma-same:$(FOREIGN_ARCH)
	# Upgrade the other and it's now possible to configure them
	$(DPKG_UNPACK) pkg-ma-same_2.0_$(FOREIGN_ARCH).deb
	$(DPKG_CONFIGURE) --pending
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-foreign-allowed

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-foreign-allowed: ma-setup
	# Ensure we can cross-grade Multi-Arch: foreign/allowed
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-foreign_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-allowed_1.0_$(NATIVE_ARCH).deb
	$(DPKG_PURGE) pkg-ma-foreign:$(NATIVE_ARCH) pkg-ma-allowed:$(FOREIGN_ARCH)

TEST_CASES_CROSSGRADE :=
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-same
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-any-all-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-same
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-foreign
TEST_CASES_CROSSGRADE += test-crossgrade-all-any-allowed
TEST_CASES_CROSSGRADE += test-crossgrade-same-all
TEST_CASES_CROSSGRADE += test-crossgrade-no

test-crossgrade: $(TEST_CASES_CROSSGRADE)

test-crossgrade-any-all-%: ma-setup
	# M-A: $* / Upgrade from arch: any-native -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_field_is,pkg-ma-$*,Architecture,all)
	$(DPKG_PURGE) pkg-ma-$*
	$(call pkg_is_not_installed,pkg-ma-$*)
	# M-A: $* / Upgrade from arch: any-foreign -> all
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-all-any-%: ma-setup
	# M-A: $* / Upgrade from arch: all -> any-native
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(NATIVE_ARCH).deb
	$(call pkg_is_installed,pkg-ma-$*:$(NATIVE_ARCH))
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_field_is,pkg-ma-$*,Architecture,$(NATIVE_ARCH))
	$(DPKG_PURGE) pkg-ma-$*:$(NATIVE_ARCH)
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_not_installed,pkg-ma-$*:$(NATIVE_ARCH))
	# M-A: $* / Upgrade from arch: all -> any-foreign
	$(DPKG_INSTALL) pkg-ma-$*_1.0_all.deb
	$(DPKG_INSTALL) pkg-ma-$*_1.0_$(FOREIGN_ARCH).deb
	$(call pkg_is_not_installed,pkg-ma-$*:all)
	$(call pkg_is_installed,pkg-ma-$*:$(FOREIGN_ARCH))
	$(DPKG_PURGE) pkg-ma-$*

test-crossgrade-same-all: ma-setup
	# Several M-A: same installed, can't upgrade to single arch all
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(NATIVE_ARCH).deb
	$(DPKG_INSTALL) pkg-ma-same_1.0_$(FOREIGN_ARCH).deb
	! $(DPKG_INSTALL) pkg-ma-same_1.0_all.deb
	$(call pkg_is_installed,pkg-ma-same:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-same:$(FOREIGN_ARCH))
	$(call pkg_is_not_installed,pkg-ma-same:all)
	$(DPKG_PURGE) pkg-ma-same:$(NATIVE_ARCH) pkg-ma-same:$(FOREIGN_ARCH)

pkg-ma-no_1.0_$(NATIVE_ARCH) pkg-ma-no_1.0_$(FOREIGN_ARCH):: pkg-template
	echo "A conffile" > $@/m-a/conffile-$@
	echo "/m-a/conffile-$@" > $@/DEBIAN/conffiles

test-crossgrade-no: ma-setup
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(NATIVE_ARCH).deb
	$(DPKG_REMOVE) pkg-ma-no:$(NATIVE_ARCH)
	$(call pkg_status_is,pkg-ma-no:$(NATIVE_ARCH),deinstall ok config-files)
	$(call pkg_is_not_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no,/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(DPKG_INSTALL) pkg-ma-no_1.0_$(FOREIGN_ARCH).deb
	# Verify the replaced package disappeared
	$(call pkg_is_not_installed,pkg-ma-no:$(NATIVE_ARCH))
	$(call pkg_is_installed,pkg-ma-no:$(FOREIGN_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(FOREIGN_ARCH))
	# Ensure the conffile of the disappeared package is still tracked
	$(call stdout_has,$(DPKG_QUERY) -L pkg-ma-no:$(FOREIGN_ARCH),/m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH))
	$(call stdout_has,$(DPKG_QUERY) -f '$${Conffiles}' -W pkg-ma-no:$(FOREIGN_ARCH), /m-a/conffile-pkg-ma-no_1.0_$(NATIVE_ARCH) [a-f0-9]+ obsolete$$)
	$(DPKG_PURGE) pkg-ma-no:$(FOREIGN_ARCH)

TEST_CASES_DEPS :=
TEST_CASES_DEPS += test-deps-same

=== tests/t-predepends-no-triggers/Makefile ===
TESTS_DEB := pkg-real pkg-predepends pkg-trigger

include ../Test.mk

test-case:
	# Install the file trigger
	$(DPKG_INSTALL) pkg-trigger.deb
	# Install the pre-dependency with --no-triggers
	$(DPKG_INSTALL) --no-triggers pkg-real.deb
	$(call pkg_status_is,pkg-real,install ok triggers-awaited)
	# Should pass even if not yet configured...
	$(DPKG_UNPACK) --no-triggers pkg-predepends.deb
	# ...by running the required triggers
	$(call pkg_status_is,pkg-real,install ok installed)
	# Retry again, this time the trigger processing is not required
	# because pkg-real has already been configured once
	$(DPKG_PURGE) pkg-predepends
	$(DPKG_INSTALL) --no-triggers pkg-real.deb
	$(call pkg_status_is,pkg-real,install ok triggers-awaited)
	$(DPKG_UNPACK) --no-triggers pkg-predepends.deb
	$(call pkg_status_is,pkg-real,install ok triggers-awaited)
	# Cleanup
	$(DPKG_PURGE) pkg-predepends
	$(DPKG_PURGE) pkg-real
	$(DPKG_PURGE) pkg-trigger

test-clean:
	-$(DPKG_PURGE) pkg-predepends pkg-real pkg-trigger

=== tests/t-switch-dir-to-symlink-rel/Makefile ===
TESTS_DEB := \
	pkg-dir-conffile-0 pkg-dir-conffile-1 \
	pkg-dir-file-other pkg-dir-symlink-int-0 pkg-dir-symlink-int-1 \
	pkg-dir-file-moved pkg-dir-symlink-ext-0 pkg-dir-symlink-ext-1

include ../Test.mk

build-hook:
	mkdir -p pkg-dir-conffile-1/test-path
	ln -sfT ../test-dir pkg-dir-conffile-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-ext-1/test-path
	ln -sfT ../test-dir pkg-dir-symlink-ext-1/test-path/test-subpath
	mkdir -p pkg-dir-symlink-int-1/test-path
	ln -sfT ../test-dir pkg-dir-symlink-int-1/test-path/test-subpath

clean-hook:
	$(RM) pkg-dir-conffile-1/test-path/test-subpath
	-rmdir pkg-dir-conffile-1/test-path
	$(RM) pkg-dir-symlink-ext-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-ext-1/test-path
	$(RM) pkg-dir-symlink-int-1/test-path/test-subpath
	-rmdir pkg-dir-symlink-int-1/test-path

test-case:
	# Cannot switch a directory containing conffiles
	$(DPKG_INSTALL) pkg-dir-conffile-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-conffile-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-conffile

	# Cannot switch a directory containing files owned by another package
	$(DPKG_INSTALL) pkg-dir-file-other.deb
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-file-other

	# Cannot switch a directory containing local files
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	touch '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	! $(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	rm '$(DPKG_INSTDIR)/test-path/test-subpath/local file'
	$(DPKG_PURGE) pkg-dir-symlink-int

	#
	# Otherwise allow the switch
	#

	# Switch a directory to a symlink, contents moved within the package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-symlink-int-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with full install, upgrade with unpack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved within the package,
	# with two unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-int-0.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-symlink-int-1.deb
	! test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_CONFIGURE) pkg-dir-symlink-int
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_PURGE) pkg-dir-symlink-int
	! test -e '$(DPKG_INSTDIR)/test-path/test-subpath'

	# Switch a directory to a symlink, contents moved to another package,
	# with intermediate full installs.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_INSTALL) pkg-dir-symlink-ext-1.deb
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with full installs, upgrade with unpack and configure.
	$(DPKG_INSTALL) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_INSTALL) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

	# Switch a directory to a symlink, contents moved to another package,
	# with three unpacks and configure.
	$(DPKG_UNPACK) pkg-dir-symlink-ext-0.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	$(DPKG_UNPACK) pkg-dir-file-moved.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_UNPACK) pkg-dir-symlink-ext-1.deb
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-dir'
	$(DPKG_CONFIGURE) -a
	test -h '$(DPKG_INSTDIR)/test-path/test-subpath'
	test -d '$(DPKG_INSTDIR)/test-path/test-subpath'
	test "`readlink '$(DPKG_INSTDIR)/test-path/test-subpath'`" = "../test-dir"
	! test -h '$(DPKG_INSTDIR)/test-dir'
	test -d '$(DPKG_INSTDIR)/test-dir'
	test -f '$(DPKG_INSTDIR)/test-dir/file-normal'
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-moved

test-clean:
	$(DPKG_PURGE) pkg-dir-conffile
	$(DPKG_PURGE) pkg-dir-symlink-int
	$(DPKG_PURGE) pkg-dir-symlink-ext
	$(DPKG_PURGE) pkg-dir-file-other
	$(DPKG_PURGE) pkg-dir-file-moved

=== debian/changelog ===
dpkg (1.22.21ubuntu4) resolute; urgency=medium

  * Copy across the architecture variant (LP: #2128606)

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 16 Oct 2025 18:46:02 +0200

=== scripts/t/dpkg_buildtree/src-rrr-dpkg-target-custom/debian/control ===
Source: source-rrr-dpkg-target-custom
Rules-Requires-Root: dpkg/target/custom

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-dpkg-target-subcommand/debian/control ===
Source: source-rrr-dpkg-target-subcommand
Rules-Requires-Root: dpkg/target-subcommand

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-missing/debian/control ===
Source: source-rrr-missing

Package: binary
Architecture: all

=== debian/tests/control ===
Tests:
 test-not-root
Depends:
 build-essential,
 autoconf,
 pkgconf,
 libmd-dev,
 file,
Restrictions:
 superficial
 skippable

Tests:
 test-root
Depends:
 build-essential,
 autoconf,
 pkgconf,
 libmd-dev,
 file,
Restrictions:
 superficial
 needs-root
 breaks-testbed

Tests:
 test-func
Depends:
 @,
 eatmydata,
Restrictions:
 allow-stderr

Tests:
 test-func-root
Depends:
 @,
 eatmydata,
Restrictions:
 allow-stderr
 needs-root
 breaks-testbed

## dpkg 1.22.21ubuntu5

=== tests/Makefile ===
#
# Dpkg functional testsuite (kind of)
#
# Copyright © 2008-2015 Guillem Jover <guillem@debian.org>
#


-include .pkg-tests.conf

## Feature checks setup ##

include Feature.mk

## Test cases ##

TESTS_MANUAL :=
TESTS_MANUAL += t-deb-lfs
TESTS_MANUAL += t-conffile-prompt

TESTS_FAIL :=
TESTS_FAIL += t-dir-leftover-deadlock
TESTS_FAIL += t-dir-shared-replaces-lost
TESTS_FAIL += t-breaks-multiarch

TESTS_PASS :=
TESTS_PASS += t-db
TESTS_PASS += t-normal
TESTS_PASS += t-field-priority
TESTS_PASS += t-option-dry-run
TESTS_PASS += t-option-recursive
TESTS_PASS += t-control-bogus
TESTS_PASS += t-control-no-arch
TESTS_PASS += t-unpack-symlink
TESTS_PASS += t-unpack-hardlink
TESTS_PASS += t-unpack-divert-hardlink
TESTS_PASS += t-unpack-divert-nowarn
TESTS_PASS += t-unpack-divert-overwrite
TESTS_PASS += t-unpack-fifo
ifdef DPKG_AS_ROOT
# No permissions for devices
TESTS_PASS += t-unpack-device
endif
TESTS_PASS += t-maintscript-leak
TESTS_PASS += t-filtering
TESTS_PASS += t-depends
TESTS_PASS += t-dir-leftover-parents
TESTS_PASS += t-dir-leftover-conffile
TESTS_PASS += t-disappear
TESTS_PASS += t-disappear-depended
TESTS_PASS += t-disappear-diverted
TESTS_PASS += t-disappear-diverted-other
TESTS_PASS += t-disappear-empty
TESTS_PASS += t-provides
TESTS_PASS += t-provides-self
TESTS_PASS += t-provides-arch-implicit
TESTS_PASS += t-provides-arch-qualified
TESTS_PASS += t-breaks
TESTS_PASS += t-breaks-protected
TESTS_PASS += t-breaks-essential
TESTS_PASS += t-conflicts
TESTS_PASS += t-conflicts-replaces
TESTS_PASS += t-conflict-provide-replace-real
TESTS_PASS += t-conflict-provide-replace-virtual
TESTS_PASS += t-conflict-provide-replace-virtual-multiarch
TESTS_PASS += t-conflict-provide-replace-interface
TESTS_PASS += t-predepends-no-triggers
TESTS_PASS += t-triggers
TESTS_PASS += t-triggers-db
TESTS_PASS += t-triggers-configure
TESTS_PASS += t-triggers-path
TESTS_PASS += t-triggers-depends
TESTS_PASS += t-triggers-depcycle
TESTS_PASS += t-triggers-depfarcycle
TESTS_PASS += t-triggers-selfcycle
TESTS_PASS += t-triggers-cycle
TESTS_PASS += t-triggers-halt
TESTS_PASS += t-file-conflicts
TESTS_PASS += t-file-replaces
TESTS_PASS += t-file-replaces-disappear
TESTS_PASS += t-file-replaces-versioned
TESTS_PASS += t-conffile-normal
TESTS_PASS += t-conffile-obsolete
TESTS_PASS += t-conffile-orphan
TESTS_PASS += t-conffile-forcemiss
TESTS_PASS += t-conffile-forcenew
TESTS_PASS += t-conffile-forceask
TESTS_PASS += t-conffile-root-option
TESTS_PASS += t-conffile-divert-normal
TESTS_PASS += t-conffile-divert-conffile
TESTS_PASS += t-conffile-conflict
TESTS_PASS += t-conffile-replaces
TESTS_PASS += t-conffile-replaces-upgrade
TESTS_PASS += t-conffile-replaces-downgrade
TESTS_PASS += t-conffile-replaces-existing
TESTS_PASS += t-conffile-replaces-existing-and-upgrade
TESTS_PASS += t-conffile-replaces-disappear
TESTS_PASS += t-conffile-replaces-diverted
TESTS_PASS += t-conffile-versioned-replaces-downgrade
TESTS_PASS += t-conffile-rename
TESTS_PASS += t-conffile-declarative-removal
TESTS_PASS += t-queue-process-deconf-dupe
TESTS_PASS += t-symlink-dir
TESTS_PASS += t-switch-symlink-abs-to-dir
TESTS_PASS += t-switch-symlink-rel-to-dir
TESTS_PASS += t-switch-dir-to-symlink-abs
TESTS_PASS += t-switch-dir-to-symlink-rel
TESTS_PASS += t-failinst-failrm
TESTS_PASS += t-dir-extension-check
TESTS_PASS += t-multiarch

ifneq (,$(filter test-all,$(DPKG_TESTSUITE_OPTIONS)))
TESTS := $(TESTS_PASS) $(TESTS_FAIL) $(TESTS_MANUAL)
else
TESTS := $(TESTS_PASS)
endif


# By default do nothing
all help::
	@echo "Run 'make test' to run all the tests"
	@echo "Run 'make installtest' to run all the tests as installed"
	@echo "Run 'make <test-id>-test' to run a specifict test"
	@echo "Run 'make clean' to remove all intermediary files"
	@echo ""
	@echo "The available tests are: $(TESTS)"

build_targets = $(addsuffix -build,$(TESTS))

build:: $(build_targets)
$(build_targets)::
	$(MAKE) -C $(subst -build,,$@) build

.PHONY: build $(build_targets)


test_targets = $(addsuffix -test,$(TESTS))

test:: export DPKG_BUILDTREE=$(realpath ..)
test:: $(test_targets)
$(test_targets)::
	$(MAKE) -C $(subst -test,,$@) test

installtest: $(test_targets)

.PHONY: test $(test_targets)


test_clean_targets = $(addsuffix -test-clean,$(TESTS))

test-clean:: $(test_clean_targets)
$(test_clean_targets)::
	$(MAKE) -C $(subst -test-clean,,$@) test-clean

.PHONY: test-clean $(test_clean_targets)


clean_targets = $(addsuffix -clean,$(TESTS))

clean:: $(clean_targets)
$(clean_targets)::
	$(MAKE) -C $(subst -clean,,$@) clean

.PHONY: clean $(clean_targets)

=== tests/t-breaks/Makefile ===
TESTS_DEB := lib-a-0 lib-a-1 lib-b-0 lib-b-1 pkg-c

include ../Test.mk

DPKG_OPTIONS += --auto-deconfigure

test-case:
	$(DPKG_INSTALL) lib-a-0.deb lib-b-0.deb
	$(DPKG_INSTALL) pkg-c.deb lib-a-1.deb lib-b-1.deb

test-clean:
	$(DPKG_PURGE) lib-a lib-b pkg-c

=== tests/t-conffile-forceask/Makefile ===
TESTS_DEB := pkg-conff-forceask-0 pkg-conff-forceask-1

include ../Test.mk

test-case:

	# Test that we get the new conffile after a modified one.
	$(DPKG_INSTALL) pkg-conff-forceask-0.deb
	$(BEROOT) cp mod-conffile "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_INSTALL) --force-confask --force-confnew pkg-conff-forceask-1.deb
	cmp mod-conffile "$(DPKG_INSTDIR)/test-conffile.dpkg-old"
	cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
	$(DPKG_PURGE) pkg-conff-forceask

test-clean:
	$(DPKG_PURGE) pkg-conff-forceask

=== tests/t-conffile-forcenew/Makefile ===
TESTS_DEB := pkg-conff-forcenew-0 pkg-conff-forcenew-1

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conff-forcenew-0.deb
	# Modify the conffile.
	$(BEROOT) cp mod-conffile "$(DPKG_INSTDIR)/test-conffile"
	# Test that we do not get the new conffile.
	$(DPKG_INSTALL) pkg-conff-forcenew-0.deb
	cmp mod-conffile "$(DPKG_INSTDIR)/test-conffile"
	# Test that we get the new conffile.
	$(DPKG_INSTALL) --force-confnew pkg-conff-forcenew-1.deb
	cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"

test-clean:
	$(DPKG_PURGE) pkg-conff-forcenew

=== tests/t-conffile-obsolete/Makefile ===
TESTS_DEB := pkg-conff-obsolete-0 pkg-conff-obsolete-1 pkg-conff-obsolete-2

include ../Test.mk

test-case:
	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
	$(DPKG_INSTALL) pkg-conff-obsolete-1.deb
	test -f '$(DPKG_INSTDIR)/test-conffile'
	$(DPKG_PURGE) pkg-conff-obsolete
	test ! -f '$(DPKG_INSTDIR)/test-conffile'
	# Unmodified conffile is autoremoved for the user
	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
	$(DPKG_UNPACK) pkg-conff-obsolete-2.deb
	test -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'
	$(DPKG_CONFIGURE) pkg-conff-obsolete
	test ! -f '$(DPKG_INSTDIR)/test-conffile'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
	$(DPKG_PURGE) pkg-conff-obsolete
	# Modified conffile is moved away in .dpkg-bak for the user
	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
	$(BEROOT) sh -c "echo foo >>'$(DPKG_INSTDIR)/test-conffile'"
	$(DPKG_INSTALL) pkg-conff-obsolete-2.deb
	test ! -f '$(DPKG_INSTDIR)/test-conffile'
	test -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
	$(DPKG_PURGE) pkg-conff-obsolete
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
	# Abort-upgrade restores the to-be-removed conffile
	$(DPKG_INSTALL) pkg-conff-obsolete-0.deb
	$(BEROOT) touch '$(DPKG_INSTDIR)/fail-preinst'
	$(DPKG_INSTALL) pkg-conff-obsolete-2.deb || true
	$(BEROOT) rm -f '$(DPKG_INSTDIR)/fail-preinst'
	test -f '$(DPKG_INSTDIR)/test-conffile'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-remove'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-bak'
	test ! -f '$(DPKG_INSTDIR)/test-conffile.dpkg-backup'

test-clean:
	$(DPKG_PURGE) pkg-conff-obsolete

=== tests/t-conffile-replaces-diverted/Makefile ===
TESTS_DEB := pkg-conff-0 pkg-conff-1 pkg-conff-move

include ../Test.mk

DPKG_DIVERT_OPTIONS += --local --rename --divert /test/conffile.moved

test-case:
	$(DPKG_INSTALL) pkg-conff-0.deb
	$(DPKG_DIVERT_ADD) /test/conffile
	test -f '$(DPKG_INSTDIR)/test/conffile.moved'
	# Test if the other package can takeover a diverted conffile w/o error.
	$(DPKG_INSTALL) pkg-conff-1.deb
	$(DPKG_INSTALL) pkg-conff-move.deb

test-clean:
	$(DPKG_DIVERT_DEL) /test/conffile
	$(DPKG_PURGE) pkg-conff
	$(DPKG_PURGE) pkg-conff-move

=== tests/t-conffile-replaces/Makefile ===
TESTS_DEB := pkg-conff-original pkg-conff-takeover

include ../Test.mk

TEST_CASES += test-two-run-ordered
TEST_CASES += test-one-run-ordered
TEST_CASES += test-two-run-reverse
TEST_CASES += test-one-run-reverse

test-case: $(TEST_CASES)

define VERIFY
$(call pkg_is_installed,pkg-conff-original)
$(call pkg_is_installed,pkg-conff-takeover)
test "`$(DPKG_QUERY) -S /test-conffile`" = "pkg-conff-takeover: /test-conffile"
cmp ref-conffile "$(DPKG_INSTDIR)/test-conffile"
endef

test-two-run-ordered:
	# test-two-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-ordered:
	# test-one-run-ordered
	$(DPKG_INSTALL) pkg-conff-original.deb pkg-conff-takeover.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-two-run-reverse:
	# test-two-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover.deb
	$(DPKG_INSTALL) pkg-conff-original.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

test-one-run-reverse:
	# test-one-run-reverse
	$(DPKG_INSTALL) pkg-conff-takeover.deb pkg-conff-original.deb
	$(VERIFY)
	$(DPKG_PURGE) pkg-conff-original pkg-conff-takeover

=== tests/t-conffile-root-option/Makefile ===
TESTS_DEB := pkg-conff-a-1 pkg-conff-a-2 pkg-conff-b-1 pkg-conff-b-2

include ../Test.mk

TEST_CASES += test-conffile-move-packages-no-rootdir
TEST_CASES += test-conffile-move-packages-rootdir

test-case: $(TEST_CASES)

test-conffile-move-packages-no-rootdir:
	# Install base versions.
	$(DPKG_INSTALL) pkg-conff-a-1.deb pkg-conff-b-1.deb
	# Install update, conffile moves from a to b.
	$(DPKG_INSTALL) pkg-conff-a-2.deb pkg-conff-b-2.deb
	# Cleanup.
	-$(DPKG_PURGE) pkg-conff-b
	-$(DPKG_PURGE) pkg-conff-a

TEST_ROOT := $(CURDIR)/target

test-conffile-move-packages-rootdir: override DPKG_ADMINDIR = $(TEST_ROOT)/var/lib/dpkg
test-conffile-move-packages-rootdir: override DPKG_INSTDIR = $(TEST_ROOT)
test-conffile-move-packages-rootdir:
	# Create template root dir.
	mkdir -p $(DPKG_ADMINDIR)/info
	mkdir -p $(DPKG_ADMINDIR)/updates
	mkdir -p $(DPKG_ADMINDIR)/triggers
	touch $(DPKG_ADMINDIR)/status
	# Install base versions.
	$(DPKG_INSTALL) pkg-conff-a-1.deb pkg-conff-b-1.deb
	# Install update, conffile moves from a to b.
	$(DPKG_INSTALL) pkg-conff-a-2.deb pkg-conff-b-2.deb
	# Cleanup.
	-$(DPKG_PURGE) pkg-conff-b
	-$(DPKG_PURGE) pkg-conff-a

test-clean:
	-$(DPKG_PURGE) pkg-conff-a pkg-conff-b
	-$(BEROOT) rm -rf $(TEST_ROOT)

=== tests/t-conflicts/Makefile ===
TESTS_DEB := pkg-a pkg-b

include ../Test.mk

test-case:
	# test if the conflicting packages fail on install
	! $(DPKG_INSTALL) pkg-b.deb pkg-a.deb
	$(call pkg_is_not_installed,pkg-a)
	-$(DPKG_PURGE) pkg-a pkg-b
	! $(DPKG_INSTALL) pkg-a.deb pkg-b.deb
	$(call pkg_is_not_installed,pkg-b)
	-$(DPKG_PURGE) pkg-a pkg-b

	# Test installation generating removal of conflicts.
	$(DPKG_INSTALL) pkg-b.deb
	# Set up the desired transaction.
	echo pkg-b deinstall | $(BEROOT) $(DPKG) --set-selections
	$(DPKG_INSTALL) pkg-a.deb
	$(call pkg_is_installed,pkg-a)
	$(call pkg_is_not_installed,pkg-b)
	-$(DPKG_PURGE) pkg-a pkg-b

test-clean:
	-$(DPKG_PURGE) pkg-a pkg-b

=== tests/t-control-bogus/Makefile ===
include ../Test.mk

test-case:
	# test building package with bogus control files
	! $(DPKG_BUILD_DEB) pkg-bogus-colon
	! $(DPKG_BUILD_DEB) pkg-bogus-blank
	! $(DPKG_BUILD_DEB) pkg-bogus-fieldname-empty
	! $(DPKG_BUILD_DEB) pkg-bogus-fieldname-partial
	! $(DPKG_BUILD_DEB) pkg-bogus-format-string
	
	# build bogus packages
	$(DPKG_BUILD_DEB) --no-check pkg-bogus-colon
	$(DPKG_BUILD_DEB) --no-check pkg-bogus-blank
	$(DPKG_BUILD_DEB) --no-check pkg-bogus-fieldname-empty
	$(DPKG_BUILD_DEB) --no-check pkg-bogus-fieldname-partial
	$(DPKG_BUILD_DEB) --no-check pkg-bogus-format-string
	
	# test installing packages with bogus control files
	! $(DPKG_INSTALL) pkg-bogus-colon.deb
	$(call pkg_is_not_installed,pkg-bogus-colon)
	! $(DPKG_INSTALL) pkg-bogus-blank.deb
	$(call pkg_is_not_installed,pkg-bogus-blank)
	! $(DPKG_INSTALL) pkg-bogus-fieldname-empty.deb
	$(call pkg_is_not_installed,pkg-bogus-fieldname-empty)
	! $(DPKG_INSTALL) pkg-bogus-fieldname-partial.deb
	$(call pkg_is_not_installed,pkg-bogus-fieldname-partial)
	! $(DPKG_INSTALL) pkg-bogus-format-string.deb
	$(call pkg_is_not_installed,pkg-bogus-format-string)

test-clean:
	rm -f pkg-bogus-colon.deb
	rm -f pkg-bogus-blank.deb

=== tests/t-db/Makefile ===
# Copyright © 2012 Guillem Jover <guillem@debian.org>

TESTS_DEB :=

include ../Test.mk

PKG_TUPLE = LC_ALL=C $(DPKG_QUERY) -f '$${Package}:$${Architecture}:$${Version}' -W

TEST_CASES += test-field-blank-lines
TEST_CASES += test-field-blank-lines-update
TEST_CASES += test-dupe-multi
TEST_CASES += test-cross-single-update
TEST_CASES += test-cross-multi-update
TEST_CASES += test-bogus-single
TEST_CASES += test-bogus-dupe-same-single
TEST_CASES += test-bogus-dupe-diff-single
TEST_CASES += test-bogus-multi
TEST_CASES += test-bogus-multi-update
TEST_CASES += test-bogus-versioned-provides
TEST_CASES += test-bogus-versioned-provides-update

test-case: $(TEST_CASES)

test-field-blank-lines: override DPKG_ADMINDIR = db-field-blank-lines
test-field-blank-lines:
	$(call stderr_has,$(PKG_TUPLE),warning)

test-field-blank-lines-update: override DPKG_ADMINDIR = db-field-blank-lines-update
test-field-blank-lines-update:
	$(call stderr_has,$(PKG_TUPLE),warning)

test-dupe-multi: override DPKG_ADMINDIR = db-dupe-multi
test-dupe-multi:
	$(call stdout_is,$(PKG_TUPLE),pkg-multi:amd64:1.0)

test-cross-single-update: override DPKG_ADMINDIR = db-cross-single-update
test-cross-single-update:
	$(call stdout_is,$(PKG_TUPLE),pkg-single:armel:3.0)

test-cross-multi-update: override DPKG_ADMINDIR = db-cross-multi-update
test-cross-multi-update:
	$(call stdout_is,$(PKG_TUPLE),pkg-multi:armel:4.0)

test-bogus-dupe-same-single: override DPKG_ADMINDIR = db-bogus-dupe-same-single
test-bogus-dupe-same-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-dupe-diff-single: override DPKG_ADMINDIR = db-bogus-dupe-diff-single
test-bogus-dupe-diff-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-single: override DPKG_ADMINDIR = db-bogus-single
test-bogus-single:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-multi: override DPKG_ADMINDIR = db-bogus-multi
test-bogus-multi:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-multi-update: override DPKG_ADMINDIR = db-bogus-multi-update
test-bogus-multi-update:
	$(call stderr_has,$(PKG_TUPLE),error)

test-bogus-versioned-provides: override DPKG_ADMINDIR = db-bogus-versioned-provides
test-bogus-versioned-provides:
	$(call stderr_has,$(PKG_TUPLE),warning)

test-bogus-versioned-provides-update: override DPKG_ADMINDIR = db-bogus-versioned-provides-update
test-bogus-versioned-provides-update:
	$(call stderr_has,$(PKG_TUPLE),warning)

=== tests/t-depends/Makefile ===
TESTS_DEB := \
	pkg-real pkg-depends \
	pkg-version-1 pkg-version-2 pkg-version-3 pkg-depends-eq \
	pkg-depends-lt pkg-depends-le pkg-depends-ge pkg-depends-gt

include ../Test.mk

test-depends:
	# The dependency is not present, fail
	! $(DPKG_INSTALL) pkg-depends.deb
	# Install the real package
	$(DPKG_INSTALL) pkg-real.deb
	# The dependency is present, pass
	$(DPKG_INSTALL) pkg-depends.deb
	# The dependency is removed, fail
	! $(DPKG_PURGE) pkg-real
	# The depending package is removed, pass
	$(DPKG_PURGE) pkg-depends
	# The dependency is removed, pass
	$(DPKG_PURGE) pkg-real
	# Now try with --force-depends
	$(DPKG_INSTALL) --force-depends pkg-depends.deb
	$(DPKG_PURGE) pkg-depends

define PURGE_DEPENDS
$(DPKG_PURGE) pkg-depends-lt
$(DPKG_PURGE) pkg-depends-le
$(DPKG_PURGE) pkg-depends-eq
$(DPKG_PURGE) pkg-depends-ge
$(DPKG_PURGE) pkg-depends-gt
endef

test-depends-versioned:
	$(PURGE_DEPENDS)

	# The dependency is not present, fail
	! $(DPKG_INSTALL) pkg-depends-lt.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	! $(DPKG_INSTALL) pkg-depends-gt.deb

	# Install the package v1
	$(DPKG_INSTALL) pkg-version-1.deb
	$(DPKG_INSTALL) pkg-depends-lt.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	! $(DPKG_INSTALL) pkg-depends-ge.deb
	! $(DPKG_INSTALL) pkg-depends-gt.deb

	$(PURGE_DEPENDS)

	# Install the package v2
	$(DPKG_INSTALL) pkg-version-2.deb
	! $(DPKG_INSTALL) pkg-depends-lt.deb
	$(DPKG_INSTALL) pkg-depends-le.deb
	$(DPKG_INSTALL) pkg-depends-eq.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	! $(DPKG_INSTALL) pkg-depends-gt.deb

	$(PURGE_DEPENDS)

	# Install the package v3
	$(DPKG_INSTALL) pkg-version-3.deb
	! $(DPKG_INSTALL) pkg-depends-lt.deb
	! $(DPKG_INSTALL) pkg-depends-le.deb
	! $(DPKG_INSTALL) pkg-depends-eq.deb
	$(DPKG_INSTALL) pkg-depends-ge.deb
	$(DPKG_INSTALL) pkg-depends-gt.deb

	$(PURGE_DEPENDS)

test-case: test-depends test-depends-versioned

test-clean:
	-$(DPKG_PURGE) pkg-depends
	-$(DPKG_PURGE) pkg-real
	-$(DPKG_PURGE) pkg-depends-lt
	-$(DPKG_PURGE) pkg-depends-le
	-$(DPKG_PURGE) pkg-depends-eq
	-$(DPKG_PURGE) pkg-depends-ge
	-$(DPKG_PURGE) pkg-depends-gt
	-$(DPKG_PURGE) pkg-version

=== debian/changelog ===
dpkg (1.22.21ubuntu5) resolute; urgency=medium

  * scripts/mk/buildflags.mk: Don't overwrite existing definitions of the
    SPACE and COMMA make macros.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 28 Oct 2025 22:36:48 +0100

=== tests/t-buildinfo/pkg-source/debian/changelog ===
test-source (1.0) UNRELEASED; urgency=medium

  * Initial release.

 -- Dpkg Developers <debian-dpkg@lists.debian.org>  Fri, 09 Dec 2016 18:48:32 +0100

=== scripts/t/dpkg_buildtree/src-build-api-v0/debian/control ===
Source: source-build-api-v0
Build-Depends:
 dpkg-build-api (= 0),

Package: binary
Architecture: all

=== scripts/t/dpkg_buildtree/src-rrr-impl-specific-keyword/debian/control ===
Source: source-rrr-impl-specific-keyword
Rules-Requires-Root: impl/specific-keyword

Package: binary
Architecture: all

## dpkg 1.22.21ubuntu6

=== tests/t-disappear-diverted/Makefile ===
TESTS_DEB := pkg-normal pkg-divert pkg-disappear

include ../Test.mk

test-case:
	# Test not disappearing diverted package.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should not disappear while it's being diverted.
	$(call pkg_is_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-divert
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear
	:
	# Test disappearing package not being diverted.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-normal.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should have been disappeared now.
	$(call pkg_is_not_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear
	:
	# Test disappearing package diverted but replaced by a 3rd package.
	$(DPKG_INSTALL) pkg-disappear.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-divert.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_INSTALL) pkg-normal.deb
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	# Should have been disappeared now, as it is diverted by a 3rd package.
	$(call pkg_is_not_installed,pkg-disappear)
	$(DPKG_PURGE) pkg-normal
	test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-divert
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal
	! test -e $(DPKG_INSTDIR)/test-dir/test-normal.distrib
	$(DPKG_PURGE) pkg-disappear

test-clean:
	$(DPKG_PURGE) pkg-divert
	$(DPKG_PURGE) pkg-disappear
	$(DPKG_PURGE) pkg-normal

=== debian/changelog ===
dpkg (1.22.21ubuntu6) resolute; urgency=medium

  * Drop unused elf-package-metadata specs files
  * dpkg-buildflags: set --package-metadata directly in LDFLAGS instead of
    exporting ELF_PACKAGE_METADATA (Closes: #1117999, LP: #2071468)
  * Include architecture variant in ELF package metadata (LP: #2131806)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 18 Nov 2025 15:53:47 +0100

## dpkg 1.22.21ubuntu7

=== debian/changelog ===
dpkg (1.22.21ubuntu7) resolute; urgency=medium

  * Revert the dpkg-buildflags change from last upload.  This would
    introduce regressions for packages not correctly picking up flags
    from the command line.  If such a change should be made, it should
    be made after an LTS release, together with the commitment to check
    the build artifact in the archive. Still, don't export the env vars
    DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH, DEB_SOURCE, DEB_VERSION.
    See LP: #2071468.
    Also include the architecture variant in the env var. See LP: #2131806.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Dec 2025 14:16:48 +0100

## dpkg 1.22.21ubuntu8

=== debian/changelog ===
dpkg (1.22.21ubuntu8) resolute; urgency=medium

  * Fix typo in the last patch.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 09 Dec 2025 10:51:48 +0100

## dpkg 1.22.21ubuntu9

=== debian/changelog ===
dpkg (1.22.21ubuntu9) resolute; urgency=medium

  * Escape { and } for --package-metadata as well (LP: #2136829)

 -- Benjamin Drung <bdrung@ubuntu.com>  Thu, 18 Dec 2025 20:18:21 +0100
